# ec2_snapshot_copy – copies an EC2 snapshot and returns the new Snapshot ID

New in version 2.4.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Copies an EC2 Snapshot from a source region to a destination region.

## Requirements

The below requirements are needed on the host that executes this module.

- boto

- boto3

- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key

debug_botocore_endpoint_logs
boolean
added in 2.8

Choices:
- no ←
- yes

Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.

description - |  | An optional human-readable string describing purpose of the new Snapshot.
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.

encrypted
boolean

Choices:
- no ←
- yes

Whether or not the destination Snapshot should be encrypted.

kms_key_id - |  | KMS key id used to encrypt snapshot. If not specified, defaults to EBS Customer Master Key (CMK) for that account.
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
source_region - / required |  | The source region the Snapshot should be copied from.
source_snapshot_id - / required |  | The ID of the Snapshot in source region that should be copied.
tags - |  | A hash/dictionary of tags to add to the new Snapshot; '{"key":"value"}' and '{"key":"value","key":"value"}'

validate_certs
boolean

Choices:
- no
- yes ←

When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.

wait
boolean

Choices:
- no ←
- yes

Wait for the copied Snapshot to be in 'Available' state before returning.

wait_timeout - added in 2.6 | Default: 600 | How long before wait gives up, in seconds.

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`

- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html

- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    # Basic Snapshot Copy
    - ec2_snapshot_copy:
        source_region: eu-central-1
        region: eu-west-1
        source_snapshot_id: snap-xxxxxxx

    # Copy Snapshot and wait until available
    - ec2_snapshot_copy:
        source_region: eu-central-1
        region: eu-west-1
        source_snapshot_id: snap-xxxxxxx
        wait: yes
        wait_timeout: 1200   # Default timeout is 600
      register: snapshot_id

    # Tagged Snapshot copy
    - ec2_snapshot_copy:
        source_region: eu-central-1
        region: eu-west-1
        source_snapshot_id: snap-xxxxxxx
        tags:
            Name: Snapshot-Name

    # Encrypted Snapshot copy
    - ec2_snapshot_copy:
        source_region: eu-central-1
        region: eu-west-1
        source_snapshot_id: snap-xxxxxxx
        encrypted: yes

    # Encrypted Snapshot copy with specified key
    - ec2_snapshot_copy:
        source_region: eu-central-1
        region: eu-west-1
        source_snapshot_id: snap-xxxxxxx
        encrypted: yes
        kms_key_id: arn:aws:kms:eu-central-1:XXXXXXXXXXXX:key/746de6ea-50a4-4bcb-8fbc-e3b29f2d367b

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
snapshot_id string | when snapshot copy is successful | snapshot id of the newly created snapshot Sample: snap-e9095e8c

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Deepak Kothandan (@Deepakkothandan) <deepak.kdy@gmail.com>

Hint

If you notice any issues in this documentation, you can edit this document to improve it.